/*
 * generated by Xtext 2.17.0
 */
package org.eclipse.gef.dot.internal.language.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.gef.dot.internal.language.escstring.EscString;
import org.eclipse.gef.dot.internal.language.escstring.EscstringPackage;
import org.eclipse.gef.dot.internal.language.escstring.JustifiedText;
import org.eclipse.gef.dot.internal.language.services.DotEscStringGrammarAccess;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;

@SuppressWarnings("all")
public class DotEscStringSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private DotEscStringGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == EscstringPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case EscstringPackage.ESC_STRING:
				sequence_EscString(context, (EscString) semanticObject); 
				return; 
			case EscstringPackage.JUSTIFIED_TEXT:
				sequence_JustifiedText(context, (JustifiedText) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     EscString returns EscString
	 *
	 * Constraint:
	 *     lines+=JustifiedText*
	 */
	protected void sequence_EscString(ISerializationContext context, EscString semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     JustifiedText returns JustifiedText
	 *
	 * Constraint:
	 *     ((text=TEXT justification=Justification?) | justification=Justification)
	 */
	protected void sequence_JustifiedText(ISerializationContext context, JustifiedText semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
